
/*Ai mehods are implemented here (at the moment just boids)
 *
 *
 *
 *created by: Uros Cibej
 *created on: 22. 2. 2001
 */



#define WEIGHT1 0.01f
#define WEIGHT2 0.02f
#define WEIGHT3 0.01f
#define INFL_DISTANCE 3    //the distance between soldiers when they begin to influence each others paths
#define DISTANCE_VEL_DECREASE 3

#include "stdafx.h"
#include <math.h>
#include "AiMethods.hpp"
#include "Group.hpp"
#include "Environment.hpp"
//#include "CollAvoidance.h"
#include "TextDisplay.hpp"
#include "Vectordir.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern TextDisplay *mainDisplay;
extern DrawStruct draw;

int count = 0;

AiMethods::AiMethods(Group* grp, Environment* environment)
{
	pGroup = grp;
	env = environment;
}


////////////////////////////////////////////////////////////////////////////////////////////////////////

// trying to stay in center, and tryin to mach the velocity of others
// WEIGHT1 and WEIGHT3 are weights of the influence of this factors on the velocity of the soldier
// They are currently constant, but they could become variables

Vector AiMethods::BoidRule13(Soldier* sol)
{
	int num=0;
	Vector center(0,0);
	Vector avgVelocity(0,0);
	Vector diff(0,0);
/*	Soldier* tempSol;
	tempSol = (Soldier*) pGroup->soldierList->getFirst();
	while(tempSol != NULL)
	{
		if ((tempSol != sol)&&(tempSol->getCoords()-sol->getCoords()).length()<2.0f)
		{
			center = center + tempSol->getCoords();
			avgVelocity = avgVelocity + tempSol->getMoveVector(); 
			num++;
		}
		diff = sol->getCoords() - pGroup->GetCenter();
		tempSol = (Soldier*) pGroup->soldierList->getNext();
	}
	if (num == 0) return center;
	center = center * (1/(float)num);				//center vector
	avgVelocity = avgVelocity * (1/(float)num);		//average velocity of the group

	//returns a vector -> sum of vectors of two rules
	return (center - sol->getCoords()) * WEIGHT1 //+ (avgVelocity -sol->getMoveVector())*WEIGHT3;
*/
	diff = pGroup->GetCenter() - sol->getCoords();
	if (diff.length() < 1) 
	{
		diff.x = 0;
		diff.y = 0;
	}
	return diff;
}


//collision avoidance rule with other soldiers
Vector AiMethods::BoidRule2(Soldier* sol)
{
	Vector c(0,0);
	Vector res(0,0);

	Soldier* tempSol;
	
	tempSol = (Soldier*) pGroup->m_pEnv->soldiers.getFirst();
	while (tempSol != NULL)
	{
		if (tempSol != sol){
/*			float angle1, angle2;
			angle1 = angleOfVector(sol->getCoords(),tempSol->getCoords());
			angle2=sol->getMoveAngle();
			if ((fabs(angleDifference(angle1, angle2))<PI/2)&&(tempSol->getCoords()-sol->getCoords()).length()<INFL_DISTANCE)   //if distance between soldiers < then..
			{
				//c = c - (tempSol->getCoords() - sol->getCoords());
				
				c = (tempSol->getCoords() - sol->getCoords());
		//		mainDisplay->display ("Avoidance vector = : %.2lf, %.2lf", c.x, c.y);
				if (angleDifference(angle2, angle1)>0)
				{
					c = rotateVector(c, PI/2.0f);
				}
				else
				{
					c = rotateVector(c, -PI/2.0f);
				}
				res = res + c;
		//		mainDisplay->display ("Rotated vector = : %.2lf, %.2lf", c.x, c.y);
			}
*/

			// Gregor

			Vector distance = sol->getCoords() - tempSol->getCoords();
			Vector inverse;
			if (distance.length() < 1)
			{
				if (distance.length() < 0.01) 
				{
//					exit (30);
				}
				inverse = distance * (float(5) / (distance.lengthSquared() * distance.lengthSquared()));
				res = res + inverse;
			}

		}
		tempSol = (Soldier*) pGroup->m_pEnv->soldiers.getNext();
	}
	
	return res;

}

////////////////////////////////////////////////////////////////////////////////////////////////////////

//this function reduces the speed of the soldiers when they have to turn on the waypoint
//the reduction depends on the angle of turn
//it does not reduce the speed under 2 m/s

Vector AiMethods::BoundSpeed(int id, Vector vel, Soldier* sol)
{  
	Vector firstWP = pGroup->m_aSoldierItems[id].m_aWaypoints[pGroup->m_aSoldierItems[id].m_iCurrWaypoint];

	Vector vecToNext;
	Vector vecToWP = sol->getCoords() - firstWP;
	float cosFi;
	if (( vecToWP.length() < sol->getSpeed()*0.5f) && (sol->getSpeed() > 2.0f ))
	{
		Vector c(0,0);
		if (pGroup->m_aSoldierItems[id].m_iCurrWaypoint + 1 == pGroup->m_aSoldierItems[id].m_iWaypointCount) return vel*0.2f;

		vecToNext = pGroup->m_aSoldierItems[id].m_aWaypoints[pGroup->m_aSoldierItems[id].m_iCurrWaypoint] - firstWP;  
		
		cosFi = (sol->getMoveVector() * vecToNext)/(sol->getSpeed() * vecToNext.length());

		if(cosFi>=0)vel = vel * cosFi; 

		if (vel.length() < 2.0f)
		{
			vel = vel * (2.0f/vel.length());
		}

		return vel;
	}
	else return vel;
}
		

////////////////////////////////////////////////////////////////////////////////////////////////////////

//the main AI function...
//this funtion will calculate the new direction and speed of the soldier 
//according to some attributes and states 

Vector AiMethods::calculateVector(int id)
{
	Soldier * psold = pGroup->m_aSoldierItems[id].m_pSoldier;
	
	Vector position = psold->getCoords();
	Vector V0, V1, V2, vel;
	Vector nul(0,0);
	
	// normiran vetor smeri, kam je nas vojak namenjen
	// uporabno takrat, kadar je lahko movevector=0,0...
	Vector destination;
	destination.x=(float)(cos (psold->getMoveAngle()));
	destination.y=(float)(sin (psold->getMoveAngle()));
	

//	V0 = *(Vector*)pGroup->wayPointList->getFirst() - psold->getCoords();
	V0 = pGroup->m_aSoldierItems[id].m_aWaypoints[pGroup->m_aSoldierItems[id].m_iCurrWaypoint] - psold->getCoords();	// GREGOR

//	V0 = V0* (psold->calculateMaxSpeed(psold->getMoveType())/V0.length()); //maximal speed to first waypoint
//	V0 = V0* float(float(3)/V0.length()); //maximal speed to first waypoint
	
//	V1 = BoidRule13(psold);
	V2 = BoidRule2(psold);

	Vector collision = env->m_CollAvoid.GetCollAvoidanceVector(psold->getCoords(), destination * (psold->getSpeed() + 0.5f));

//	float desirSpeed = (float)fabs(psold->calculateMaxSpeed(psold->getMoveType()));

	float desirSpeed = (float)fabs(psold->calculateMaxSpeed(psold->getMoveType()));
	vel = V0;
	vel = vel*(desirSpeed/vel.length());
	vel = vel + collision ;
	vel = vel + V2;
//	psold->setMaxAngleDifference(0.1f,true);
	vel = BoundSpeed(id, vel, psold);
	
	draw.SetSoldierVectors(id, position, psold->getMoveVector(), V0, nul, V2, collision, vel);
	
	return vel;
}