
/* AiMethods.hpp, 1.0
 *The main function in the AiMethods class is calculateVector(Soldier* sol)
 * it returns a new vector for the soldier sol.
 *
 *We are going to add new attributes and states, which will affect the calculation of
 *the "move" vector
 *
 *created by: Uros Cibej
 *created on: 22. 2. 2001
 */

#ifndef __AIMETHODS__
#define __AIMETHODS__


#include "Soldier.hpp"
#include "Group.hpp"

class Group;


class AiMethods 
{
private:
	Group* pGroup;						//which group are we in
	Environment* env;
	Vector BoidRule13(Soldier* sol);	//the 1st and the 3rd boids rule (centering and matching the velocity)
	Vector BoidRule2(Soldier* sol);		//the 2nd rule (collision avoidance)
	Vector BoundSpeed(int id, Vector vel, Soldier* sol);

public:
	AiMethods(Group* grp, Environment* env);
	Vector calculateVector(int id);				//returns the new vector for the soldier sol
};







#endif //AiMethods