// $Id: Automaton.cpp,v 1.2 2001/05/01 10:10:27 mitja Exp $

/* Automaton.cpp, 1.3, 2001-05-01, Mitja Lustrek
 *
 * See header file.
 */

#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include "Automaton.hpp"
#include "State.hpp"
#include "Group.hpp"
#include "Environment.hpp"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

////////////////////////////////////////////////////////////////////////////////////////////////////////

Automaton::Automaton (Group *grp, Environment *env, char fileName1 [], int maxStates1)
{
	int i;

	strcpy (fileName, fileName1);
	maxStates=maxStates1;
	weights=new float *[maxStates];
	states=new State *[maxStates];
	for (i=0; i<maxStates; i++)
		weights [i]=NULL;
	readWeightsFromFile ();
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

Automaton::~Automaton ()
{
	int i;

	for (i=0; i<maxStates; i++)
	{
		delete weights [i];
		delete states [i];
	}
	delete weights;
	delete states;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

void Automaton::readWeightsFromFile ()
{
	int i, j, maxWeights;
	char iniBuffer [100], dirBuffer [200], dirAndFile [300], sectionName [10], keyName [10];

	GetCurrentDirectory (sizeof (dirBuffer), dirBuffer);
	sprintf (dirAndFile, "%s\\%s", dirBuffer, fileName);
	maxWeights=GetPrivateProfileInt ("main", "maxWeights", 1, dirAndFile);
	for (i=0; i<maxStates; i++)
	{
		if (weights [i]!=NULL)
			delete weights [i];
		weights [i]=new float [maxWeights];
		for (j=0; j<maxWeights; j++)
		{
			sprintf (sectionName, "state%d", i);
			sprintf (keyName, "weight%d", j);
			GetPrivateProfileString (sectionName, keyName, "0", iniBuffer, sizeof (iniBuffer), dirAndFile);
			weights [i][j]=(float)(atof (iniBuffer));
		}
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

float Automaton::getWeight (int which)
{
	return weights [currentState][which];
}

////////////////////////////////////////////////////////////////////////////////////////////////////////

void Automaton::update ()
{
	int newState;

	newState=states [currentState]->update ();
	if (newState!=currentState)
	{
		states [currentState]->leave ();
		currentState=newState;
		states [currentState]->enter ();
	}
}