// $Id: Group.hpp,v 1.3 2001/03/05 08:28:53 damir Exp $

/* AutomatonMDM.hpp, 1.2, 2001-04-06, Mitja Lustrek
 */

#ifndef __AUTOMATONMDM__
#define __AUTOMATONMDM__

#include "Automaton.hpp"

class State;
class Group;
class Environment;

class AutomatonMDM: public Automaton
{
public:
	enum tWeightMDM {WEIGHT_CLOCK_RATE=3, WEIGHT_TIME_TO_LEAVE=4, WEIGHT_MAX_ORDERED=5, WEIGHT_AIM_LIMIT=6, WEIGHT_SNAP_LIMIT=7, WEIGHT_STOP_ADVANCE=8, WEIGHT_ADVANCE_SPEED=9, WEIGHT_STRENGTH_PRESENCE=10, WEIGHT_STRENGTH_TOLERANCE_DOWN=11, WEIGHT_STRENGTH_TOLERANCE_UP=12, WEIGHT_SHOOT_SQUARE=13, WEIGHT_SOLDIER_RADIUS=14, WEIGHT_QUALITY_ADDITION=15, WEIGHT_LEADER_RANGE=16, WEIGHT_MIN_DISTANCE=17, WEIGHT_SAFETY_SQUARE=18, WEIGHT_DISTANCE_INFLUENCE=19}; // weights
	enum tState {STATE_INIT, STATE_IDLE, STATE_TO_SAFETY, STATE_DUG_IN, STATE_MARCHING, STATE_ATTACKING_ADVANCING, STATE_ATTACKING, STATE_RETREATING};                                                                                                                                                                                                                                                                                                                 // states

public:
	AutomatonMDM (Group *grp, Environment *env, char fileName []); // construct automaton for given group and environment that reads weights from given file
};

#endif //__AUTOMATONMDM__