
// $Id: auxiliary.hpp,v 1.12 2001/04/08 15:40:52 mitja Exp $

/* Auxiliary functions
 *
 * Here are a few functions of a more general nature that can be used for different
 * purposes in all parts of the code.
 *
 * The functions are mostly of geometric nature at the moment but that could
 * change.
 *
 * Created by: Mitja Lustrek
 * Created on: 23.11.2000
 */

#include <stdlib.h>
#include "Vector.hpp"

// some general arithmetic macros
#define MIN(a, b) ((a)<(b)?(a):(b))
#define MAX(a, b) ((a)>(b)?(a):(b))
#define RANDOM(x) (float)((((float)rand())/RAND_MAX)*(x))

#define PI 3.141592654f

// angle functions
float angleFormat(float angle);                    // Convert given angle to an angle between 0 and 2*PI
float angleDifference(float angle1, float angle2); // Calculate difference between given angles: if angle2 is right from angle 1 return positive value, otherwise return negative value
float angleOfVector(Vector from, Vector to);       // Calculate angle of vector between two points
Vector rotateVector(Vector v, float angle);        //rotates Vector for angle
// intersection functions
int circleIntersectsCircle(Vector C1, float R1, Vector C2, float R2);  // do two circles intersect?
int circleIntersectsLine(Vector C, float R, Vector Dot1, Vector Dot2); // do a line and a circle intersect?

// distance functions
float circleHitByLineSegment(Vector center, float radius, Vector start, Vector end); // how well the circle was hit by the line segment

// random generators
float randomGauss(); // returns a random value according to normal Gauss distribution

