
// $Id: BulletClient.hpp,v 1.6 2001/04/08 15:40:52 mitja Exp $

/* Bullet class on the client
 *
 * Extended Bullet class that now allows drawing of the bullets at their coordinates.
 * Created by: Matija Jekovec
 * Created on: 22.11.2000
 */

#ifndef __BULLET_CLIENT__
#define __BULLET_CLIENT__

#include "Viewport.hpp"
#include "PicCollection.hpp"

#define  BULLET_CLIENT_RADIUS 4

class BulletClient
{
private:
	int *pics;           /* array of integers, that represent the images of the bullet's
                          *  state in the PicCollection object */
	PicCollection *maps; /* pointer to the PicCollection object containing the bitmaps
                            of bullets */
	float x,y;           // bullet coordinates
	float lastX;         // previous coordinates used for interpolation
	float lastY;		
	int   bulletId;      // id of bullet

public:
	// constructor, assigns values to maps and pics pointers
	BulletClient(PicCollection *aMaps, int *aPics[], float ax, float ay, int aBulletId);

	/* draws the bullet at its coordiantes to the surface, using and converting the 
	   coordinates in the viewport, taking account of the zoom.*/
	void  DrawBullet(Viewport* viewport,  SDL_Surface *surface);	

	// get methods for the protected members, set methods also set the last... members
	float GetX();
	void  SetX(float value);
	float GetY();
	void  SetY(float value);
	int   GetId();
	int   updated;
};

#endif // __BULLET_CLIENT__
