
// $Id: Changes.cpp,v 1.6 2001/04/11 06:49:24 damir Exp $

/* Implementation of Changes class - for ad. info. see  header.
 *
 * Created by: Martin Znidarsic
 * Created on: 20.2.2001
 * Version 0.0
 */

#include "stdafx.h"

#include <iostream.h>
#include <stdlib.h>
#include <memory.h> 
#include "Changes.hpp"
#include "soldier.hpp"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


// Vrne char pointer Buffer, ki je zapakirani paket, ki ga posljem clientu.
// Rabi pa seznam vojkaov, ki ga dobim pred tem iz environmenta - po update.
void * Changes::pack(List *psoldierlist, List *pbulletlist, int *len)
{
	Soldier     *psol;
	Bullet      *pbull;
	SoldierPack newsol;
	BulletPack  newbull;
	int  i;
	char *Buffer;
	
	
	Buffer =(char *) malloc(2*sizeof(int) + psoldierlist->getNumItems() * sizeof(SoldierPack) +
		pbulletlist->getNumItems() * sizeof(BulletPack));
	
	
	psol =(Soldier *) psoldierlist->getFirst();	// Soldierlist provided by Env.
	i = 0;
	
	int numS = psoldierlist->getNumItems();
	memcpy(&Buffer[0], &numS, sizeof(int));
	int numP =  pbulletlist->getNumItems();
	memcpy(&Buffer[sizeof(int)], &numP, sizeof(int));
	int iBullOff = 2* sizeof(int) +(psoldierlist->getNumItems() * sizeof(SoldierPack));
	
	while (psol != NULL)
	{
		Vector v = psol->getCoords();
		newsol.x = v.x;
		newsol.y = v.y;
		newsol.viewAngle = psol->getViewAngle();
		newsol.moveAngle = psol->getMoveAngle();
		newsol.fieldOfView = psol->getFieldOfView();
		newsol.health = psol->getHealth();
		newsol.ID = psol->getID();
		newsol.aiID = psol->getAiID();
		newsol.moveType = psol->getMoveType();
		
		memcpy(&Buffer[2*sizeof(int) + i * sizeof(SoldierPack)], &newsol, sizeof(SoldierPack));
		i++;
		psol =(Soldier *) psoldierlist->getNext();
	}
	
	pbull =(Bullet *) pbulletlist->getFirst();
	i = 0;
	while (pbull != NULL)
	{
		Vector v = pbull->getCoords();
		newbull.x= v.x;
		newbull.y= v.y;
		newbull.ID= pbull->getID();
		
		memcpy(&Buffer[iBullOff + i * sizeof(BulletPack)], &newbull, sizeof(BulletPack));
		i++;
		pbull =(Bullet *) pbulletlist->getNext();
	}
	*len = iBullOff + pbulletlist->getNumItems() * sizeof(BulletPack);
	return Buffer;
}




/*
Funkcija za odpakiranje :
				- napolni OrderPack pop
				- napolni tabelo item-ov (ID, count, *list)
*/
void Changes::unpack(OrderPack *pop, item arritems[], char *ppack)
{
	int sizepop, i, j, newindex;
	List *pListPP;		// Rabim pri MOVE
	PathPack *ppp;
	int *pid;
	
	List *pListID;		// Rabim pri GROUPUPDATE
	
	
	
	// Pobere OrderPack iz paketa - tako kot prej.
	// numItems je st.grup ali pa st.waypointov.
	memcpy(pop, &ppack[0], sizeof(OrderPack));
	
	sizepop = sizeof(OrderPack);
	


	switch(pop->orderType){
    
	case MOVE:
		pListPP = new List;
		newindex = sizepop;
		// Najprej spravi groupID v ID prvega in edinega item-a
		memcpy(&(arritems[0].ID), &(pop->groupID)/*ppack[newindex]*/, sizeof(int));

		// Nato spravi stevilo Pathpackov (dolzina seznama) v count
		// To je po moje isto kot: arritems[0].count=pop->numItems;
		memcpy(&(arritems[0].count), &(pop->numItems), sizeof(int));

		// Zdaj ustvarjeni new List napolnim in povezem item z njim...
		for (i=0; i<pop->numItems; i++){
			newindex = sizepop + i*sizeof(PathPack);
			
			ppp = new PathPack;
			*ppp = *(PathPack *)&ppack[newindex];	//Vanj zapisem vrednost
			pListPP->add(ppp);						//In ga dodam seznamu
		}
	
		arritems[0].plist =  pListPP;		//In povezem

		break;

	case ADDAOD:
		// Vsi (edini) AREAOD bodo v seznamu prve celice tabele arritems
        newindex = sizepop;
		pListID = new List;

		for(i=0; i<pop->numItems; i++){
				
			AODpack* paod = new AODpack;
			memcpy(paod, &ppack[newindex], sizeof(AODpack));
			pListID->add(paod);
			newindex=newindex+sizeof(AODpack);
		}
		arritems[0].plist = pListID;
		break;

	case AGRESS:
		//
        newindex = sizepop;
		pListID = new List;

		for(i=0; i<pop->numItems; i++){
			
			int* id = new int;
			memcpy(id, &ppack[newindex], sizeof(int));
			pListID->add(id);
			newindex=newindex+sizeof(int);
		}
		arritems[0].plist = pListID;
		break;

	case REAOD:
		// Seznam prve celice bo NULL - na serverju bom, ze ko bom vedel za tip ukaza.., vedel vse
        newindex = sizepop;

		arritems[0].plist = NULL;
		break;

    case GROUPUPDATE:
        newindex = sizepop;
		// Po vseh grupah, torej po celicah tabele...
		// SE ENKRAT PAZI KAKO SE SPREMINJA NEWINDEX !!!!!!!!!!!!!!
		for(i=0; i<pop->numItems; i++){
			// Spravim groupID v ID i-tega itema
			memcpy(&(arritems[i].ID), &ppack[newindex], sizeof(int));
			newindex = newindex + sizeof(int);

			// Nato spravim stevilo vojakov v count
			// Tokrat se count polni iz paketa.
			memcpy(&(arritems[i].count), &ppack[newindex], sizeof(int));
			newindex = newindex + sizeof(int);

			//Zdaj ustvarjeni new List napolnim in povezem item z njim...
			pListID = new List;		// Za vsako celico je nov.
// MOGOCE JE ZG. VRSTA NAROBE - BI MORAL TO NA ZACETKU, POTEM PA GA PRAZNIT? - POZANIMAJ SE!
// SE BOLJ VERJETNO PA JE ZMESNJAVA S KAZALCEM NA INTEGERJE...TU SPODAJ!
			for(j=0; j<arritems[i].count; j++){
				pid = new int;
				memcpy(pid, &ppack[newindex], sizeof(int));
				//*pid = *(int *)&ppack[newindex];
				newindex = newindex + sizeof(int);
				pListID->add(pid);

			}
			arritems[i].plist = pListID;
		}



    default :
        newindex=0; // Mogoce kdaj kaksen izpis o napaki.
	}
		
}
