// CollAvoidance.h: interface for the CCollAvoidance class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COLLAVOIDANCE_H__DB88F811_0E3B_11D5_AB22_0040F654ADFD__INCLUDED_)
#define AFX_COLLAVOIDANCE_H__DB88F811_0E3B_11D5_AB22_0040F654ADFD__INCLUDED_

#include "Vector.hpp"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class Vector;
class Square;


// class that creates and uses a map of vectors that  is used when we want to 
// avoid collision with stationary objects
class CCollAvoidance  
{
public:
	bool GetEdges (Square **map, int x, int y, short TopLeft, short TopRight, short BottomRight, short BottomLeft);
	bool GetSurrounding(Square **map, int x, int y, short top, short right, short bottom, short left);
	CCollAvoidance();						// standard constructor
	virtual ~CCollAvoidance();				// destructor

	int CreateVectMap (Square ** map, int iXSize, int iYSize);		// creates Vector array and fills it 
	void PrintToFile (Square **map, char *name);					// print valuest of m_aVectors to file
	void ClearMap();												// dipose all alocated data

	Vector GetVectorAt (int x, int y);								// reads value in Vector array at (x,y)
	Vector GetCollAvoidanceVector (Vector soldierPosition, Vector direction);	// calculates vector values for a soldier - called from AI main class

	Vector	** m_aVectors;		// array of vectors
	int		m_iXSize;			// x size of m_aVectors
	int		m_iYSize;			// y size of m_aVectors

private:
	int GetPassability(Square ** map, int x, int y);
};

#endif // !defined(AFX_COLLAVOIDANCE_H__DB88F811_0E3B_11D5_AB22_0040F654ADFD__INCLUDED_)
