#include "stdafx.h"
#include "DangerMap.hpp"
#include <stdio.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "flood.h"

// calculates the index in the matrix array
#define INDEX(X, Y)(X + Y*sizeX)


DangerMap::DangerMap()
{
	dangerMatrix = NULL;
	sizeX = 0;
	sizeY = 0;
}

DangerMap::~DangerMap()
{
	if (dangerMatrix) delete dangerMatrix;
	dangerMatrix = NULL;
}

void DangerMap::CreateDangerMap(Environment *env, Square** map, int Xsize, int Ysize)
{
	sizeX = Xsize;
	sizeY = Ysize;

	CFlood flood;
	if (!flood.LoadDangerMap("danger.val", &dangerMatrix, Xsize * Ysize))
	{
		flood.BuildDangerMap(env, "danger.val", 2);
		flood.LoadDangerMap("danger.val", &dangerMatrix, Xsize * Ysize);
	}
	
	flood.Free();
}

int DangerMap::GetSafety(int x, int y)
{
	if (x > sizeX) return 0;
	if (x < 0) return 0;
	if (y > sizeY) return 0;
	if (y < 0) return 0;
	return dangerMatrix[INDEX(x,y)];
}



