// Flood.h: interface for the CFlood class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FLOOD_H__C257DB11_3555_11D5_AB8E_0040F654ADFD__INCLUDED_)
#define AFX_FLOOD_H__C257DB11_3555_11D5_AB8E_0040F654ADFD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define OFFSET 4	// koliko kvadratkov pristejemo na obeh straneh

#include "Environment.hpp"
#include "vector.hpp"

class Vector;
class Environment;

class CFlood  
{
public:
	void PrintDanger(char *array, Environment *env);
	bool LoadDangerMap (char *filename, char **pMap, int size);
	int CountTrue();
	void BuildDangerMap (Environment *env, char *filename, int offset);
	void Printout();
	CFlood();
	virtual ~CFlood();

	void Free();
	
	// izracuna obmocje, na katerega lahko pridemo iz tocke begin z dolocenim offsetom
	void FloodArea(Vector begin, Vector end, Environment *env, int Xoff = OFFSET, int Yoff = OFFSET);
	
	// pogleda, ce je obmocje dosegljivo 
	int GetAccessibility (int x, int y);

private:
	void FillCols(int x);
	void FillLines (int y);
	
	void SetTrue(int x, int y);
	void SetFalse(int x = -1, int y = -1);
	
	int Passability(int x,int y);
	int	Accessibility(int x, int y);

	Environment * m_pEnv;
	Square ** m_pMatrix;

	bool * m_pbArea;

	int m_iMaxX;
	int m_iMaxY;

	int m_iYoff;	// offseta od osnovne mape
	int m_iXoff;

	int m_iXsize;
	int m_iYsize;
};

#endif // !defined(AFX_FLOOD_H__C257DB11_3555_11D5_AB8E_0040F654ADFD__INCLUDED_)
