// $Id: Automaton.hpp,v 1.1 2001/04/08 15:40:52 mitja Exp $

/* HeuristicsMDM.cpp, 1.0, 2001-04-15, Mitja Lustrek
 *
 * See header file.
 */

#include <math.h>
#include "HeuristicsMDM.hpp"
#include "Vector.hpp"
#include "Auxiliary.hpp"
#include "AreaOfDanger.hpp"

#define WEIGHT 1000.0f

HeuristicsMDM::HeuristicsMDM (List *areaOfDanger1)
{
	areaOfDanger=areaOfDanger1;
}

float HeuristicsMDM::distance (Vector start, Vector end)
{
	float realDistance, dangerDistance;
	AreaOfDanger *temp;
	Vector centre;

	realDistance=(float)(sqrt ((end.x-start.x)*(end.x-start.x)+(end.y-start.y)*(end.y-start.y)));
	dangerDistance=0.0f;
	temp=(AreaOfDanger *)(areaOfDanger->getFirst ());
	while (temp!=NULL)
	{
		centre.x=temp->x;
		centre.y=temp->y;
		dangerDistance+=circleHitByLineSegment (centre, temp->r, start, end)*temp->r;
		temp=(AreaOfDanger *)(areaOfDanger->getNext ());
	}
	return (1.0f+WEIGHT*dangerDistance)*realDistance;
}