
// $Id: Log.hpp,v 1.4 2001/04/13 06:56:37 damir Exp $

/* Log class
 *
 * This class offers easy and unified logging capabilities for the program.
 *
 * Nothing fancy, just basic methods to get the work done
 *
 * Created by: Damir Arh
 * Created on: 7.1.2001
 */

#ifndef __LOG__
#define __LOG__

class Log
{
private:

	FILE *handle; // log file handle
	bool enabled; // is logging enabled?

public:

	// constructors and destructors
	Log(char *filename, bool append);
	~Log(); // closes the file

	// log methods
	void print(char *string,...); // write the given string into the log and appends a newline
	bool isReady();               // returns true if logging has been succesfully started
	void enable(bool choice);     // enables or disables logging for this logfile
	bool isEnabled();             // checks if logging is currently enabled
};

#endif // __LOG__
