
// $Id: MapAttributes.cpp,v 1.2 2001/04/25 08:12:18 damir Exp $

/* MapAttributes.cpp, 1.0, 2001-04-16, Damir Arh
 *
 * Details in the header file.
 */

#include <stdlib.h>
#include "MapAttributes.hpp"
#include "Environment.hpp"

#define INDEX(X, Y)(X + 1) + (Y + 1)*(e->maxSx + 2)

MapAttributes::MapAttributes(Environment *env)
{
	e = env;
	maxSx = e->maxSx;
	maxSy = e->maxSy;
	matrix = new SquareAttr*[(maxSx + 2)*(maxSy + 2)];
	for (int j = 0; j < maxSy; j++)
		for (int i = 0; i < maxSx; i++)
			matrix[INDEX(i, j)] = NULL;
	// decendent should create proper squares and calculate their initial value
}

MapAttributes::~MapAttributes()
{
	for (int j = 0; j < maxSy; j++)
		for (int i = 0; i < maxSx; i++)
			if (matrix[INDEX(i, j)] != NULL) delete matrix[INDEX(i, j)];
	delete[] matrix;
}

SquareAttr *MapAttributes::getSquare(int x, int y)
{	
	return matrix[INDEX(x, y)];
}