
// $Id: MapAttributesMDM.cpp,v 1.0 2001-04-16 18:01:01+02 damir Exp damir $

/* MapAttributesMDM.cpp, 1.2, 2001-05-02, Damir Arh
 *
 * Details in the header file.
 */

#include <math.h>
#include "MapAttributesMDM.hpp"
#include "SquareAttrMDM.hpp"
#include "Environment.hpp"
#include "Auxiliary.hpp"

#define INDEX(X, Y)(X + 1) + (Y + 1)*(e->maxSx + 2)

MapAttributesMDM::MapAttributesMDM(Environment *env) : MapAttributes(env)
{
	Vector v1, v2, *coll, dist;
	int i, j, d;
	float px, nx, py, ny, x, y, fi, f;

	for (j = 0; j < e->maxSy; j++)
		for (i = 0; i < e->maxSx; i++)
			matrix[INDEX(i, j)] = new SquareAttrMDM;

	for (j = 0; j < e->maxSy; j++)
	{
		for (i = 0; i < e->maxSx; i++)
		{
			if (e->matrix[INDEX(i,j)]->passability)
			{
				// calculation af shelter
				if (!e->matrix[INDEX(i-1,j-1)]->passability) ((SquareAttrMDM *)matrix[INDEX(i,j)])->shelter++;
				if (!e->matrix[INDEX(i-1,j)]->passability) ((SquareAttrMDM *)matrix[INDEX(i,j)])->shelter++;
				if (!e->matrix[INDEX(i-1,j+1)]->passability) ((SquareAttrMDM *)matrix[INDEX(i,j)])->shelter++;
				if (!e->matrix[INDEX(i,j-1)]->passability) ((SquareAttrMDM *)matrix[INDEX(i,j)])->shelter++;
				if (!e->matrix[INDEX(i,j+1)]->passability) ((SquareAttrMDM *)matrix[INDEX(i,j)])->shelter++;
				if (!e->matrix[INDEX(i+1,j-1)]->passability) ((SquareAttrMDM *)matrix[INDEX(i,j)])->shelter++;
				if (!e->matrix[INDEX(i+1,j)]->passability) ((SquareAttrMDM *)matrix[INDEX(i,j)])->shelter++;
				if (!e->matrix[INDEX(i+1,j+1)]->passability) ((SquareAttrMDM *)matrix[INDEX(i,j)])->shelter++;

				// calculation of visibility
				v1.x = i * e->squareBorder + e->squareBorder/2;
				v1.y = j * e->squareBorder + e->squareBorder/2;
				px = e->maxSx * e->squareBorder - v1.x - e->squareBorder/2;
				nx = e->squareBorder/2 - v1.x;
				py = e->maxSy * e->squareBorder - v1.y - e->squareBorder/2;
				ny = e->squareBorder/2 - v1.y;
				for (d = 0; d < 16; d++)
				{
					fi = PI * d / 8;
					x = (float) cos(fi);
					y = (float) sin(fi);
					if (x != 0)
						if (y != 0) f = MIN(MAX(px/x, nx/x), MAX(py/y, ny/y));
						else f = MAX(px/x, nx/x);
					else f = MAX(py/y, ny/y);
					v2.x = v1.x + f * x;
					v2.y = v1.y + f * y;
					if (coll = e->bulletHitWall(NULL, v1, v2))
					{
						dist = v1 - *coll;
						delete coll;
					}
					else
						dist = v1 - v2;
					float distlen = dist.length();
					if (distlen > ((SquareAttrMDM *)matrix[INDEX(i,j)])->maxvisvalue)
					{
						((SquareAttrMDM *)matrix[INDEX(i,j)])->maxvisvalue = distlen;
						((SquareAttrMDM *)matrix[INDEX(i,j)])->maxvisangle = fi;
					}
					if (distlen < ((SquareAttrMDM *)matrix[INDEX(i,j)])->minvisvalue)
					{
						((SquareAttrMDM *)matrix[INDEX(i,j)])->minvisvalue = distlen;
						((SquareAttrMDM *)matrix[INDEX(i,j)])->minvisangle = fi;
					}
					((SquareAttrMDM *)matrix[INDEX(i,j)])->visvalue[d] = distlen;
					((SquareAttrMDM *)matrix[INDEX(i,j)])->visibility += distlen;
				}
			}
		}
	}
}
