
// $Id: Order.hpp,v 1.7 2001/04/08 15:40:52 mitja Exp $

/*Class Order which takes care of the users orders
 *and packs the order for sending to the server
 *
 *This header also includes the structures which are
 *needed for packing and unpacking on the client (soldierPack, bulletPack,OrderPack)
 *
 *Created by: Uros Cibej
 */

#ifndef __ORDER__
#define __ORDER__


#include "List.hpp"
#include "packages.hpp"


class Order
{
public:
	tOrder orderType;
	Order();
	float x;
	float y;
	int groupId;
	List *items;          // a list of soldiers which have to execute the order
	List **groups;
	int ready;               // a variable which indicates if the order is ready for sending
	void* pack(int *length); // returns a buffer with length in bytes
};

#endif // __ORDER__
