
// $Id: PicCollection.hpp,v 1.6 2001/04/08 15:40:52 mitja Exp $

/* Picture collection class
 *
 * Incorporates functions for cropping the surface it is based on. According to sizeX, sizeY, the surface
 * is cut apart and every image given index. 
 * Created by: Matija Jekovec
 * Created on: 22.11.2000
 */

#ifndef __PICTURE_COLLECTION__
#define __PICTURE_COLLECTION__

#include "SDL.h"

class PicCollection
{
private:
	SDL_Surface *picture; // picture, loaded from disk																	

public:
	int  sizeX, sizeY;		//size of one picture in  the surface

	// constructor, loads the bitmap into the surface and sets the sizeX and sizeY
	PicCollection(const char* fileName, int aSizeX, int aSizeY);
	~PicCollection(); // destructor, also frees the picture

	/* returns the coordinates of picture and the surface, so user has to use the x,y
	 * coordinates with sizeX, sizeY fields and surface. This way, the picture doesn't
	 * have to be copied twice and is directyl blitted to the destination surface */
	void GetPic(int index, int *x, int *y, SDL_Surface **surface);

	// returns the number of all pictures (surface.width div sizeX * surface.Height div sizeY)
	int PicCount(); 
};

#endif // __PICTURE_COLLECTION__
