
// $Id: SquareAttrMDM.cpp,v 1.2 2001-04-16 18:01:02+02 damir Exp damir $

/* SquareAttrMDM.cpp, 1.2, 2001-05-02, Damir Arh
 *
 * Details in the header file.
 */

#include "SquareAttrMDM.hpp"
#include "Auxiliary.hpp"
#include <math.h>

SquareAttrMDM::SquareAttrMDM()
{
	shelter = 0;
	visibility = 0.0f;
	maxvisangle = 0.0f;
	maxvisvalue = 0.0f;
	minvisangle = 0.0f;
	minvisvalue = 100000.0f;

	for (int i = 0; i < 16; i++)
			visvalue[i] = 0.0f;
}

float SquareAttrMDM::getVisValue(float angle)
{
	// fi = PI * d / 8;
	angle = angleFormat(angle);
	float index = angle / PI * 8;
	int i = (int) floor(index);
	int j = i + 1;
	if (j == 16) j = 0;
	index -= i;
	return visvalue[i] + index * (visvalue[j] - visvalue[i]);
}