// $Id: StatesDemo.hpp,v 1.1 2001/04/08 15:40:52 mitja Exp $

/* States.hpp, 1.2, 2001-04-06, Mitja Lustrek
 *
 * THESE ARE SAMPLE STATES OF A FINITE STATE AUTOMATON THAT CONTROLS A GROUP OF SOLDIERS.
 */

#ifndef __STATESDEMO__
#define __STATESDEMO__

#include "StateDemo.hpp"
#include "Group.hpp"
#include "Environment.hpp"
#include "Automaton.hpp"

////////////////////////////////////////////////////////////////////////////////////////////////////////

class StateNormal: public StateDemo
{
private:
	int movementTime;
	bool empty;

public:
	StateNormal (Group *grp, Environment *env, Automaton *aut);
	void enter ();
	void leave ();
	int update ();
};

////////////////////////////////////////////////////////////////////////////////////////////////////////

class StateTurn: public StateDemo
{
public:
	StateTurn (Group *grp, Environment *env, Automaton *aut);
	void enter ();
	void leave ();
	int update ();
};

////////////////////////////////////////////////////////////////////////////////////////////////////////

class StateShoot: public StateDemo
{
private:
	int shootTime;

public:
	StateShoot (Group *grp, Environment *env, Automaton *aut);
	void enter ();
	void leave ();
	int update ();
};

#endif //__STATESDEMO__