// $Id: Group.hpp,v 1.3 2001/03/05 08:28:53 damir Exp $

/* StatesMDM.hpp, 1.5, 2001-05-15, Mitja Lustrek
 */

#ifndef __STATESMDM__
#define __STATESMDM__

#include "StateMDM.hpp"
#include "Group.hpp"
#include "Environment.hpp"
#include "Automaton.hpp"
#include "Vector.hpp"

////////////////////////////////////////////////////////////////////////////////////////////////////////

class StateInit: public StateMDM
{
private:

public:
	StateInit (Group *grp, Environment *env, Automaton *aut);
	void enter ();
	void leave ();
	int update ();
};

////////////////////////////////////////////////////////////////////////////////////////////////////////

class StateIdle: public StateMDM
{
private:

public:
	StateIdle (Group *grp, Environment *env, Automaton *aut);
	void enter ();
	void leave ();
	int update ();
};

////////////////////////////////////////////////////////////////////////////////////////////////////////

class StateToSafety: public StateMDM
{
private:
	bool started;
	Vector safety;

public:
	StateToSafety (Group *grp, Environment *env, Automaton *aut);
	void enter ();
	void leave ();
	int update ();
};

////////////////////////////////////////////////////////////////////////////////////////////////////////

class StateDugIn: public StateMDM
{
private:

public:
	StateDugIn (Group *grp, Environment *env, Automaton *aut);
	void enter ();
	void leave ();
	int update ();
};

////////////////////////////////////////////////////////////////////////////////////////////////////////

class StateMarching: public StateMDM
{
private:

public:
	StateMarching (Group *grp, Environment *env, Automaton *aut);
	void enter ();
	void leave ();
	int update ();
};

////////////////////////////////////////////////////////////////////////////////////////////////////////

class StateAttackingAdvancing: public StateMDM
{
private:

public:
	StateAttackingAdvancing (Group *grp, Environment *env, Automaton *aut);
	void enter ();
	void leave ();
	int update ();
};

////////////////////////////////////////////////////////////////////////////////////////////////////////

class StateAttacking: public StateMDM
{
private:

public:
	StateAttacking (Group *grp, Environment *env, Automaton *aut);
	void enter ();
	void leave ();
	int update ();
};

////////////////////////////////////////////////////////////////////////////////////////////////////////

class StateRetreating: public StateMDM
{
private:

public:
	StateRetreating (Group *grp, Environment *env, Automaton *aut);
	void enter ();
	void leave ();
	int update ();
};

////////////////////////////////////////////////////////////////////////////////////////////////////////

class StateX: public StateMDM
{
private:

public:
	StateX (Group *grp, Environment *env, Automaton *aut);
	void enter ();
	void leave ();
	int update ();
};

#endif //__STATESMDM__