
// $Id: TuiGraphics.hpp,v 1.5 2001/04/08 21:05:50 mitja Exp $

#ifndef __TUI_GRAPHICS__
#define __TUI_GRAPHICS__

#include "SDL.h"

// defines a point
struct TUI_pointStruct
{
	float x;
	float y;
};

struct TUI_rectStruct
{
	float x;
	float y;
	float w;
	float h;
};

enum TUI_SetPixelEffects
{
	fxInvertSrc, // invert the source and override destination
	fxInvertDst, // invert the destination and ignore source
	fxSrcAnd,    // and values
	fxSrcOr,     // or the calues
	fxOverride   // just paste the src to destination
};

// support functions
TUI_pointStruct TUI_Point(float x, float y); // returns point for the coordinates
TUI_rectStruct  TUI_Rect(float x, float y, float w, float h);
TUI_pointStruct TUI_Rotate(TUI_pointStruct p, TUI_pointStruct start, float angle); // rotates a point

// drawing functions	
void TUI_Circle(SDL_Surface *surface, TUI_pointStruct p, float radius, Uint32 color, TUI_SetPixelEffects fx);           //draw a circle
void TUI_SetPixel(TUI_pointStruct p, Uint32 color, SDL_Surface *screen, TUI_SetPixelEffects fx);                        //draw a point
void TUI_Line(TUI_pointStruct pStart, TUI_pointStruct pEnd, Uint32 color, SDL_Surface *screen, TUI_SetPixelEffects fx); //draw a line
void TUI_Rect(SDL_Surface *surface, TUI_pointStruct p1, TUI_pointStruct p2, Uint32 color, TUI_SetPixelEffects fx, bool filled);      //draw a rectangle
void TUI_Numeral(int number, SDL_Surface *surface, TUI_pointStruct position, Uint32 color, TUI_SetPixelEffects fx);
void TUI_BodyPosition(int bodyPos, SDL_Surface *surface, TUI_pointStruct position, Uint32 color, TUI_SetPixelEffects fx);

extern TUI_rectStruct clipRect;

#endif // __TUI_GRAPHICS__
