
// $Id: UISP\040Client.cpp,v 1.16 2001-04-14 18:12:49+02 damir Exp damir $

//
// UISP Client.cpp : Defines the entry point for the console application.
//

/*#ifdef _DEBUG
	#include <crtdbg.h>
	#define _CRTDBG_MAP_ALLOC
	#define _CRTDBG_LEAK_CHECK
	#define _CRTDBG_DELAY_FREE_MEM
	#define _CRTDBG_CHECK_CRT
	#define _CRTDBG_CHECK_ALWAYS
	int d_counter = 0;
#endif*/

#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include "connection.h"
#include "console.hpp"
#include "BulletClient.hpp"
#include "unpackC.hpp"
#include "Order.hpp"

#include "SDL.h"	
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "BMPSaver.hpp"
#include "AviSaver.hpp"
//#include "Log.hpp" // packet congestion testing


SDL_Surface *eventScreen;
Viewport    *viewport;
Order       currOrder;
Console     *console;

int g_ClientID = -1;	// our ID is stored in here. We change this value when we receive info from server


void SoldierShoot(bool selected)
{
	if ((!selected) ||(console == NULL) ||(console->selected == NULL))
		return;
	
	currOrder.orderType = SHOOT;
	currOrder.ready = 0;
	currOrder.items = console->selected;
}


void SoldierMove(bool selected)
{
	if ((console == NULL) ||(console->selected == NULL) || (console->groupID == -1))
		return;

	//currOrder.orderType = MOVE;	
	//currOrder.items = console->waypoints;
	currOrder.ready = 0;
}

void SoldierAddWaypoint(bool selected)
{
	if ((!selected) ||(console == NULL) ||(console->waypoints == NULL))
		return;
	
	if (selected){
		console->waypoints->getFirst();
		do
			console->waypoints->remove();
		while (console->waypoints->getNext());
	}
}

void SoldierRemoveWaypoint()
{
	if ((console == NULL) || (console->selected == NULL) || !(console->displayWaypoints))
		return;

	TUI_pointStruct *temp = (TUI_pointStruct *) console->waypoints->getFirst();
	console->waypoints->remove();
	delete temp;

	console->RefreshOverlays();
}

void SoldierExecuteWaypoint()
{
	if ((console == NULL) ||(console->selected == NULL) || (console->groupID == -1))
		return;

	currOrder.orderType = MOVE;
	currOrder.groupId = console->groupID;
	currOrder.items = console->waypoints;
	currOrder.ready = 1;
}

void SoldierChangeGroup(int groupIndex, bool set)
{
	if (set)
	{
		console->DefineGroup(groupIndex);

		currOrder.groups=console->preselected;
		currOrder.orderType = GROUPUPDATE;
		currOrder.ready=1;
	}
	else 
	{
		console->SelectGroup(groupIndex);
		console->RefreshOverlays();
		SDL_Flip(console->GetScreen());
	}	//if
}

void SoldierChangeAgr(int groupIndex, float value){	
	SoldierClient *soldier = (SoldierClient*)console->selected->getFirst();

	while (soldier){
		soldier->SetAgr(value);
		soldier = (SoldierClient*)console->selected->getNext();
	}
	currOrder.orderType = AGRESS;
	currOrder.groupId = (int)(value*10.1);
	currOrder.items = console->selected;
	currOrder.ready = 1;
	
	console->RefreshOverlays();
}

void SoldierAddAOD(bool selected){
	if ((console == NULL) || (console->selected == NULL))
		return;
    currOrder.ready = 0;
	currOrder.orderType = ADDAOD;
}

void SoldierRemoveAOD(){
	if ((console == NULL) || (console->selected == NULL))
		return;
	currOrder.ready = 1;
	currOrder.orderType = REAOD;

	AreaOfDanger *temp = (AreaOfDanger *) console->areasOfDanger->getFirst();
	console->areasOfDanger->remove();
	delete temp;

	console->RefreshOverlays();
}


void ConsoleMouseDown(float x, float y, Uint8 button)
{	
	CommandPanel *cp;

	cp = console->commandPanel;

	if (cp->GetButtonEnabled() == cpMove)
	{
		if (console->groupID == -1)
			return;

		console->waypoints->getFirst();
		do
			console->waypoints->remove();
		while (console->waypoints->getNext());

		TUI_pointStruct *p = new TUI_pointStruct;

		p->x = x;
		p->y = y;

		console->waypoints->add(p);		//adds the waypoint in a list of WPs	
		currOrder.orderType = MOVE;
		currOrder.groupId = console->groupID;
		currOrder.items = console->waypoints;
		currOrder.ready = 1;
		console->RefreshOverlays();
	} else if (cp->GetButtonEnabled() == cpAddWaypoint) {
		TUI_pointStruct *p = new TUI_pointStruct;

		p->x = x;
		p->y = y;

		console->waypoints->add(p);		//adds the waypoint in a list of WPs	
		console->RefreshOverlays();
	} else if (cp->GetButtonEnabled() == cpAddAOD){
		if (cp->area == NULL)
		{
			cp->area = new AreaOfDanger();
			cp->area->x = x;
			cp->area->y = y;
			cp->area->r = 0;
		}
		else
		{
			currOrder.orderType = ADDAOD;
			cp->area->r = (float)sqrt(pow(x - cp->area->x, 2) + pow(y - cp->area->y, 2));
			console->areasOfDanger->add(cp->area);
			currOrder.items = console->areasOfDanger;
			currOrder.ready = 1;
			cp->area = NULL;
		}
	}
}


int main(int argc, char* argv[])
{
	/*#ifdef _DEBUG
	_CrtSetReportMode(_CRT_WARN, _CRTDBG_MODE_DEBUG);
	_CrtSetReportMode(_CRT_ERROR, _CRTDBG_MODE_DEBUG);
	_CrtSetReportMode(_CRT_ASSERT, _CRTDBG_MODE_DEBUG);
	//_CrtSetBreakAlloc(144);
	#endif*/

	PicCollection     picColl("scen1.bmp", 16, 16); // teksture za okolje in vojake
	EnvironmentClient env("test3.map");             // zemljevid
//	Log netLog("net.log", FALSE);  // packet congestion testing
	BMPSaver *bmpsaver;            // DAMIR: zajemanje slik
	bool capture = false;          // DAMIR: zajemanje slik
	bool avisave = false;          // DAMIR: snemanje AVI
	char ipAddr[15] = "127.0.0.1";
	
	if (argc > 1)		//just presume first param is the IP
		strcpy(ipAddr, argv[1]);

	CConnection conn;
	if (!conn.Initialize(CLIENT))
		goto end;
	if (!conn.Call(ipAddr))
		goto end;

	
	SleepEx (1000, TRUE);	// we should sleep a while so that the connection initializes ... don't know if necessary
	conn.GetClientID();		// we send the server an order for our id number

	conn.StartGame();
	
	console = new Console(2, &env);
	console->OnWorldMouseDown = ConsoleMouseDown;
	console->commandPanel->OnSelectMove = SoldierMove;
	console->commandPanel->OnSelectShoot = SoldierShoot;
	console->commandPanel->OnSelectAddWaypoint = SoldierAddWaypoint;
	console->commandPanel->OnRemoveWaypoint = SoldierRemoveWaypoint;
	console->commandPanel->OnExecuteWaypoint = SoldierExecuteWaypoint;
	console->commandPanel->OnChangeGroup = SoldierChangeGroup;
	console->commandPanel->OnSelectAddAOD = SoldierAddAOD;
	console->commandPanel->OnRemoveAOD = SoldierRemoveAOD;
	console->commandPanel->OnChangeAgr = SoldierChangeAgr;

	bmpsaver = new BMPSaver(console->GetScreen(), "capture"); // DAMIR: zajemanje slik

//	int oldtime = 0, newtime = 0, interval = 0, skip = -1; // packet congestion testing
//	char logbuf[128]; // packet congestion testing

	SDL_Event event;
	
	event.type=!SDL_KEYDOWN;
	while (true)
	{
		SleepEx(10, TRUE);
		SDL_PollEvent(&event);
		
		switch (event.type) 
		{	
			case SDL_QUIT:
				/*#if _DEBUG
				_CrtDumpMemoryLeaks();
				#endif*/
				console->scrollSpeed = 100000; // prevent scroll updates
				SleepEx (1000, TRUE); // wait for one scroll update to actually change timer				
				goto end;
				exit(0);
			case SDL_KEYUP:                    // DAMIR: zajemanje slik
				if (event.key.keysym.sym == SDLK_F1)
					capture = !capture;
				else if (event.key.keysym.sym == SDLK_F3)
				{
					if (!avisave)
					{
						if (WriteAVIFile("movie.avi", console->GetScreen(), 20) == 1)
							avisave = true;
					}
					else
					{
						CloseAVIFile();
						avisave = false;
					}
				}
		}
		
		int id;
/*		if (oldtime) // packet congestion testing
		{
			newtime = SDL_GetTicks();
			interval = newtime - oldtime;
//			if (interval > 50)
				netLog.print("%d, %d", interval, skip);
			skip = -1;
		}
		oldtime = 0; // packet congestion testing
		skip++; // packet congestion testing */
		while (conn.IsNewDataAvailable(&id))
		{
//			oldtime = SDL_GetTicks(); // packet congestion testing
			char *packet = NULL;
			int size = 0;
			
			int type = conn.Receive(id, (void **) &packet, &size);
			if (type == CLIENT_ID)
			{
				g_ClientID = *packet;		// we received our ID number
			}
			if (type == START)
			{
				// zacni kazati mapo, user lahko zacne premikati enote
			}
			else if (type == MAP)
			{
				// sprejeli smo novo mapo. ustrezno ukrepaj....
			}
			else if (type == DATA)
			{
				unpackC(&env, packet, g_ClientID);
				console->RefreshOverlays();
				SDL_Flip(console->GetScreen());
				if (capture) bmpsaver->save();       // DAMIR: zajemanje slik
				if (avisave) WriteFrame(console->GetScreen());
			}
			conn.DisposeBuffer(id);
		}
		
		if (currOrder.ready)
		{
			int length;
			char *package =(char *) currOrder.pack(&length);
			
			conn.Send(package, length);
			
			currOrder.ready = 0;
			delete package;
		}

		Viewport *av = console->viewports[/*console->GetActiveViewport()*/0];
		SoldierClient *s = (SoldierClient*)(console->selected->getFirst());
		if (av && s && console->autoScrollEnabled){
			int x = (int)((s->GetX() - av->posX) * av->GetZoom());
			int y = (int)((s->GetY() - av->posY) * av->GetZoom());

			Direction dir = console->GetScrollingDirection(x, y, av->left, av->top, av->width, av->height); // set tmp vars
			//printf("%d:%d\t%d\n",x,y, dir);	
			if (dir != dNoDirection && !console->isBeingScrolled){
				console->isBeingScrolled = true;
				console->scrollStepsLeft = (int)(av->width / SCROLL_STEP / 2);
				console->currentDirection = dir;
				SDL_SetTimer(1, &OnScrollTimer);  // immediate call
			}
		}
	}
	
end:
	if (avisave) CloseAVIFile();
	delete console;
	
	return 1;
}
