// $Id: VGVertex.hpp,v 1.4 2001/04/08 15:40:52 mitja Exp $

/* VGVertex.hpp, 1.1, 2001-3-4, Mitja Lustrek
 *
 * This is a vertex in visibility graph. It also contains some data structures used by A* algorithm.
 */

#ifndef __VGVERTEX__
#define __VGVERTEX__

#include "Square.hpp"
#include "Vector.hpp"
#include "List.hpp" 

class VGVertex
{
friend class VisGraph;

private:
	Square *square;                        // square
	int x, y;                              // coordinates of the square
	List *visible;                         // vertices visible from this one
	float asG, asH, asF;                   // A* distances
	VGVertex *asParent;                    // A* parent

	void removeVisible (VGVertex *vertex); // remove given vertex from vertices visible from this one

public:
	VGVertex (Square *square, int x, int y); // create vertex with given square and coordinates
	~VGVertex ();                            // destructor
	List *getVisible ();                     // return list of vertices visible from this one
	void addVisible (VGVertex *vertex);      // add given vertex to the list of visible vertices
	void removeItself ();                    // remove references to itself from vertices visible from itself
};

#endif //__VGVERTEX__