
// $Id: Vector.cpp,v 1.6 2001/04/08 15:42:51 mitja Exp $

#include "Vector.hpp"
#include <math.h>


Vector::Vector()
{
	x = 0.0;
	y = 0.0;
}


Vector::Vector(float x1, float y1)
{
	x = x1;
	y = y1;
}


Vector& Vector::operator=(Vector V)
{
	x = V.x;
	y = V.y;
	return *this;
}


int Vector::operator==(Vector V)
{
	return ((x == V.x) && (y == V.y));
}


Vector Vector::operator-(Vector V)
{
	Vector V1;
	V1.x = x - V.x;
	V1.y = y - V.y;
	return V1;
}


Vector Vector::operator+(Vector V)
{
	Vector V1;
	V1.x = x + V.x;
	V1.y = y + V.y;
	return V1;
}


float Vector::operator*(Vector V)
{
	return (x*V.x + y*V.y);
}


Vector Vector::operator-()
{
	Vector V1;
	V1.x=-x;
	V1.y=-y;
	return V1;
}


Vector Vector::operator*(float f)
{
	Vector V1;
	V1.x = f*x;
	V1.y = f*y;
	return V1;
}


float Vector::lengthSquared()
{
	return (x*x + y*y);
}


float Vector::length()
{
	return (float) sqrt(x*x + y*y);
}
