
// $Id: Vector.hpp,v 1.7 2001/04/08 15:40:52 mitja Exp $

/* Vector class
 *
 * This is a class for storing 2D vectors and calculating with them.
 *
 * Most of the operations are already implemented. Might get extended if
 * need arises.
 *
 * Created by: Uros Cibej
 * Created on: 22.11.2000
 */

#ifndef __VECTOR__
#define __VECTOR__

class Vector
{
public:
	// constructors and destructors
	Vector();
	Vector(float x, float y);

	// member variables for storing the actual vector value
	float x,y; 

	// overloaded operators
	Vector& operator= (Vector V); // assignment operator
	int operator== (Vector V);    // equality operator
	Vector operator- (Vector V);  // binary minus operator
	Vector operator+ (Vector V);  // binary plus operator
	float operator* (Vector V);	  // dot product
	Vector operator- ();          // unary minus operator
	Vector operator* (float f);   // multiplication with a scalar value

	float length();        // get length of the vector
	float lengthSquared(); // get squared length of the vector
};

#endif // __VECTOR__
